var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/utils.ts
import { getFileBasedRouteName } from "unplugin-vue-router";
import { debounce } from "lodash-es";
function getNuxtStyleRouteName(node) {
  var _a;
  if (((_a = node.parent) == null ? void 0 : _a.isRoot()) && node.value.pathSegment === "")
    return "index";
  let name = node.value.subSegments.map((segment) => {
    if (typeof segment === "string")
      return `-${segment}`;
    return segment.paramName;
  }).join("");
  if (node.value.filePaths.size && node.children.has("index"))
    name += "/";
  const parent = node.parent;
  return ((parent && !parent.isRoot() ? getNuxtStyleRouteName(parent).replace(/\/$/, "") : "") + name).replace(/^-|-$/, "");
}
function _getRouteMap(node, { routeMap, nuxtStyle }) {
  node.children.forEach((i) => {
    if (i.value.filePaths.get("default"))
      routeMap.set(i.value.filePaths.get("default"), i);
    if (i.children.size)
      _getRouteMap(i, { routeMap, nuxtStyle });
  });
}
function getRoot(node) {
  return node.parent ? getRoot(node.parent) : node;
}
var getRouteMap = debounce(
  (node, options) => _getRouteMap(getRoot(node), options),
  100,
  { leading: true, trailing: false }
);
var getRouteName = ({
  routeMap = /* @__PURE__ */ new Map(),
  nuxtStyle = false
}, getRouteName2 = nuxtStyle ? getNuxtStyleRouteName : getFileBasedRouteName) => (node) => {
  getRouteMap(node, { routeMap, nuxtStyle });
  return getRouteName2(node);
};

export {
  __spreadValues,
  __spreadProps,
  __objRest,
  getNuxtStyleRouteName,
  getRouteName
};
