"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils.ts
var utils_exports = {};
__export(utils_exports, {
  getNuxtStyleRouteName: () => getNuxtStyleRouteName,
  getRouteName: () => getRouteName
});
module.exports = __toCommonJS(utils_exports);
var import_unplugin_vue_router = require("unplugin-vue-router");
var import_lodash_es = require("lodash-es");
function getNuxtStyleRouteName(node) {
  var _a;
  if (((_a = node.parent) == null ? void 0 : _a.isRoot()) && node.value.pathSegment === "")
    return "index";
  let name = node.value.subSegments.map((segment) => {
    if (typeof segment === "string")
      return `-${segment}`;
    return segment.paramName;
  }).join("");
  if (node.value.filePaths.size && node.children.has("index"))
    name += "/";
  const parent = node.parent;
  return ((parent && !parent.isRoot() ? getNuxtStyleRouteName(parent).replace(/\/$/, "") : "") + name).replace(/^-|-$/, "");
}
function _getRouteMap(node, { routeMap, nuxtStyle }) {
  node.children.forEach((i) => {
    if (i.value.filePaths.get("default"))
      routeMap.set(i.value.filePaths.get("default"), i);
    if (i.children.size)
      _getRouteMap(i, { routeMap, nuxtStyle });
  });
}
function getRoot(node) {
  return node.parent ? getRoot(node.parent) : node;
}
var getRouteMap = (0, import_lodash_es.debounce)(
  (node, options) => _getRouteMap(getRoot(node), options),
  100,
  { leading: true, trailing: false }
);
var getRouteName = ({
  routeMap = /* @__PURE__ */ new Map(),
  nuxtStyle = false
}, getRouteName2 = nuxtStyle ? getNuxtStyleRouteName : import_unplugin_vue_router.getFileBasedRouteName) => (node) => {
  getRouteMap(node, { routeMap, nuxtStyle });
  return getRouteName2(node);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getNuxtStyleRouteName,
  getRouteName
});
exports.default = module.exports;